//advisman.h

#ifndef	__advisman_H
#define	__advisman_H

// Standard headers
#include <fstream.h>

// otools headers
#include "ostring.h"
#include "oopiclist.h"
#include "varg.h"

// physics headers
#include <misc.h>

class SpatialRegionGroup;
typedef oopicList<SpatialRegionGroup> SpatialRegionGroupList;
class SpeciesParams;
typedef oopicList<SpeciesParams> SpeciesParamsList;
class Species;
typedef oopicList<Species> SpeciesList;
class SpatialRegion;
typedef oopicList<SpatialRegion> SpatialRegionList;

// typedef int BOOL;

class AdvisorManager
{
  VarGroup VG;
	SpatialRegionGroupList	srgList;
	SpeciesParamsList*	speciesParamsList;
	SpeciesList*	speciesList;
	ifstream	inputFile;
	ofstream outputFile;
	ostring readSpatialRegionGroup(SpatialRegionGroup& srg);
	ostring InputErrorMessage;
	oopicList<ostring> ListOfAllBoundaryTypes;
	oopicList<ostring> ListOfAllParameterGroups;
	oopicList<ostring> ListOfAllProbeTypes;
	ostring caseTitle;
	oopicList<ostring> caseDescription;
public:
	AdvisorManager(const char* fileName);
	~AdvisorManager();
	void	describe();
	void	checkRules();
	SpatialRegionList*	createDevice();
	void setFileName(const char* fileName);
	oopicList<ostring>* getListOfAllBoundaryTypes();
	oopicList<ostring>* getListOfAllProbeTypes();
	SpatialRegionGroupList* getSpatialRegionGroupList();
	void writeOutputFile(const char* fileName);
	Species* get_speciesPtr(const ostring &speciesName);
	ostring GetErrorMessage();
	BOOL KnownBoundary(ostring &s);
	BOOL KnownSpecies(ostring &speciesName);
	ostring readSpecies(ifstream& fin);
	SpeciesParamsList* get_speciesParamsList() {return speciesParamsList;}
	SpeciesList* get_speciesList() {return speciesList;}
  void linkSRB();
};       

#endif  //  __advisman_H
