######################################################################
#
# File:	        advisor.pro
#
# Purpose:	tmake project file for advisor
#
# Version:	$Id: advisor.pro,v 1.1.2.3 2000/01/27 19:22:50 kgl Exp $
#
# Copyright 1999, Tech-X Corporation
#
######################################################################

##########
#
# tmake stuff
#
##########
TARGET		= advisor
TEMPLATE	= recproj
CONFIG		= cxx oopic xgrafix staticlib develop norules 

##########
#
# Other directories in the hierarchy
#
##########
THIS_DIR        = advisor
TOP_DIR         = ..
TXCORP_DIR      =
PROJ_DIR        = $(HOME)/projects
RULES_DIR       = $(PROJ_DIR)/projrules
RULES_FILE      = $(RULES_DIR)/$(PROJ_ENV)/rules
DOCS_DIR        = $(TOP_DIR)/docs/cxxapi/advisor
DOCS_PACKAGES   =
THIS_PACKAGE    =

##########
#
# Locations for libraries, class files, and archives
#
##########
PROJ_LIB_DIR	= $(TOP_DIR)/lib
PROJ_JSRCS_DIR	=
PROJ_CLASSES_DIR= $(TOP_DIR)/classes

##########
#
# Other libraries that this depends on and compilation defines
#
##########
PROJ_DEPS       = 
PROJ_DEFINES	= SCALAR_FLOAT
PROJ_LIBS       =

##########
#
# The various subdirectories
#
##########
IDL_DIRS        =
PURE_JAVA_DIRS  =
PURE_CXX_DIRS   =
LINKED_DIRS     = 

# All headers

HEADERS      =	\
		abswag.h \
		advisman.h \
		bemitg.h \
		boundg.h \
		conductg.h \
		controlg.h \
		cylaxisg.h \
		diagg.h \
		diags.h \
		dielecg.h \
		emitprtg.h \
		emitterg.h \
		eportg.h \
		eqpotg.h \
		femitg.h \
		foilg.h \
		gapg.h \
		gridg.h \
		iloopg.h \
		iregiong.h \
		lnchwag.h \
		loadg.h \
		mccg.h \
		param.h \
		part1g.h \
		particlg.h \
		plsmsrcg.h \
		polarg.h \
		portg.h \
		portteg.h \
		porttmg.h \
		rules.h \
		segmentg.h \
		spatialg.h \
		spboundg.h \
		speciesg.h \
		spemitg.h \
		symmetg.h \
		varg.h \
		varloadg.h \
		vbemitg.h

# Source files for creation of main target (library)

SOURCES     =	\
		abswag.cpp \
		advisman.cpp \
		bemitg.cpp \
		boundg.cpp \
		conductg.cpp \
		controlg.cpp \
		cylaxisg.cpp \
		diagg.cpp \
		diags.cpp \
		dielecg.cpp \
		emitprtg.cpp \
		emitterg.cpp \
		eportg.cpp \
		eqpotg.cpp \
		femitg.cpp \
		foilg.cpp \
		gapg.cpp \
		gridg.cpp \
		iloopg.cpp \
		iregiong.cpp \
		lnchwag.cpp \
		loadg.cpp \
		mccg.cpp \
		param.cpp \
		part1g.cpp \
		particlg.cpp \
		plsmsrcg.cpp \
		polarg.cpp \
		portg.cpp \
		portteg.cpp \
		porttmg.cpp \
		rules.cpp \
		segmentg.cpp \
		spatialg.cpp \
		speciesg.cpp \
		spemitg.cpp \
		strstuff.cpp \
		varloadg.cpp \
		vbemitg.cpp \
		
# Additional testing executables

EXECS =

# Additional files to remove with "make clean"

CLEAN_FILES  =

##########
#
# Distribution variables
#
##########

# The DIST_* variables denote items for all distributions
DIST_DIR	= ../oopic/advisor
DIST_DIRS	=
DIST_CXX_DIRS	=
DIST_EXTS	= .h .cpp
DIST_ITEMS	= 

# The variables describing extra files needed by each of
# the DIST_TYPE's: UNIX_EQ, BORLAND, WIN32_MWERKS, MACOS_MWERKS, MSVC

UNIX_EQ_ITEMS	= 
UNIX_EQ_EXTS	=
BORLAND_ITEMS	=
BORLAND_EXTS	=
MSVC_ITEMS	=
MSVC_EXTS	=
WIN32_MWERKS_ITEMS	=
WIN32_MWERKS_EXTS	=
MACOS_MWERKS_ITEMS	=
MACOS_MWERKS_EXTS	=
