//diagg.h

#ifndef   __DIAGG_H
#define   __DIAGG_H

#include "gridg.h"
#include "newdiag.h"

#ifndef UNIX
// #include "segment.h"
#endif

class SpatialRegionGroup;

//===================DiagParams  Class
// base class for all diagnostics
// abstract

class DiagParams : public BoundaryParams
{protected:
 GridParams* GP;
 SpatialRegionGroup* spatialRegionGroup;
 Diag* dPtr;
 SpatialRegion* region;
 

public:
 /* IntParameter j1;  //  Inherited from BoundaryParams now
 IntParameter k1;
 IntParameter j2;
 IntParameter k2;
 ScalarParameter A1,A2,B1,B2;
 IntParameter normal;*/
 IntParameter nfft;
 IntParameter save;
 IntParameter HistMax;
 IntParameter Ave;
 IntParameter Comb;
 StringParameter VarName;
 StringParameter integral;
 StringParameter x1Label;
 StringParameter x2Label;
 StringParameter x3Label;
 StringParameter title;

 BOOL HasLength();

	  DiagParams(GridParams *_GP,SpatialRegionGroup* srg);
	  //  since boundaries are all placed on grid, this class needs
	  //  to know the dimensions of the grid

	  virtual ~DiagParams() {};

	  //ostring AlignmentConstraint();
	  // ensures that boundary is aligned with grid

	//  ostring OnGridConstraint();
	  // ensures that boundary is on grid

	  virtual void checkRules();
	  // checks all rules associated with the class

	  virtual Diag* CreateCounterPart(SpatialRegion* region);

// void toGrid(Grid *g);

	// query function for GUI
#ifndef UNIX
	// Segment getSegment();
	// void setSegment(Segment& s);
#endif
};                                       

#endif  //  __DIAGG_H

