//gridg.h

#ifndef   __GRIDG_H
#define   __GRIDG_H

#include "part1g.h"

//=================== GridParams Class
// class for specifying the computational grid

class GridParams :public ParameterGroup
{IntParameter J;
 IntParameter K;
 ScalarParameter x1s;
 ScalarParameter x1f;
 ScalarParameter n1;
 ScalarParameter x2s;
 ScalarParameter x2f;
 ScalarParameter n2;
 StringParameter dx1;
 StringParameter dx2;
 IntParameter PeriodicFlagX1;
 IntParameter PeriodicFlagX2;
 IntParameter Geometry;  //  which geometry, RZ, XY, or even R-Theta

// storage used by GUI
protected:
	Vector2** X;

public:
	  GridParams();

	  ~GridParams();

 int getJ() {return J.getValue();}
 int getK() {return K.getValue();}
 
 int getPeriodicFlagX1() {return PeriodicFlagX1.getValue();}
 int getPeriodicFlagX2() {return PeriodicFlagX2.getValue();}

	  Scalar getX1s() {return x1s.getValue();}
	  Scalar getX1f() {return x1f.getValue();}
	  Scalar getX2s() {return x2s.getValue();}
	  Scalar getX2f() {return x2f.getValue();}

	  Scalar mapping_function(Scalar x, Scalar x1, Scalar x2, Scalar n);

	  Grid* CreateCounterPart();
#ifdef MPI_VERSION
     Grid* CreateCounterPart(const ostring &MPIpartition);
#endif /*MPI_VERSION */
public:
	Vector2** createCellVertices();
	Vector2** getCellVertices();
	void deleteCellVertices();
};



#endif  //  __GRIDG_H
