#ifndef EVALUATOR_H
#define EVALUATOR_H

#include "evaluator.tab.h"
     /* Data type for links in the chain of symbols.      */
     struct symrec
     {
       char *name;  /* name of symbol                     */
       int type;    /* type of symbol: either VAR or FNCT */
       union {
         float var;           /* value of a VAR          */
         float (*fnctptr)();  /* value of a FNCT         */
			float *ivar;          /* pointer to an external var */
       } value;
       struct symrec *next;    /* link field              */
     };

     typedef struct symrec symrec;
     
     /* The symbol table: a chain of `struct symrec'.     */
/*     extern symrec *sym_table; */

#ifdef __cplusplus
extern "C" {     
#endif
    symrec *putsym (symrec *sym_table,char *varname,int sym_type);
    symrec *getsym (symrec *sym_table,char *varname);
	  extern int yyparse();
	  void delete_table(symrec *sym_table);
	  symrec *init_table(symrec *sym_table);
	 symrec *copy_table(symrec *sym_table);
	  extern char *EVAL_STRING;
	  extern float EVAL_RESULT;
	  extern symrec *SYMBOL_TABLE;
	  extern int Sindex;
  //	  float ramp(float);
  //	  float step(float);
  //	  float pulse(float);
/* #ifndef UNIX
	  float SINW(float x)  { return (float)sin(x);  }
	  float COSW(float x)  { return (float)cos(x);  }
	  float ATANW(float x) { return (float)atan(x); }
	  float TANHW(float x) { return (float)tan(x);  }
#else */
  //	  float SINW(float ); 
  //	  float COSW(float ); 
  //	  float ATANW(float );
  //	  float TANHW(float ); 
/* #endif */
  //	  float LOGW(float);
  //	  float EXPW(float);
  //	  float SQRTW(float);
  //	  float POWW(float);
#ifdef __cplusplus
}
#endif


#endif
