######################################################################
#
# File:	        physics.pro
#
# Purpose:	tmake project file for physics
#
# Version:	$Id: physics.pro,v 1.1.2.3 2000/01/27 19:24:28 kgl Exp $
#
# Copyright 1999, Tech-X Corporation
#
######################################################################

##########
#
# tmake stuff
#
##########
TARGET		= physics
TEMPLATE	= recproj
CONFIG		= cxx oopic xgrafix staticlib develop norules 

##########
#
# Other directories in the hierarchy
#
##########
THIS_DIR        = physics
TOP_DIR         = ..
TXCORP_DIR      =
PROJ_DIR        = $(HOME)/projects
RULES_DIR       = $(PROJ_DIR)/projrules
RULES_FILE      = $(RULES_DIR)/$(PROJ_ENV)/rules
DOCS_DIR        = $(TOP_DIR)/docs/cxxapi/physics
DOCS_PACKAGES   =
THIS_PACKAGE    =

##########
#
# Locations for libraries, class files, and archives
#
##########
PROJ_LIB_DIR	= $(TOP_DIR)/lib
PROJ_JSRCS_DIR	=
PROJ_CLASSES_DIR= $(TOP_DIR)/classes

##########
#
# Other libraries that this depends on and compilation defines
#
##########
PROJ_DEPS       = 
PROJ_DEFINES	= SCALAR_FLOAT
PROJ_LIBS       =

##########
#
# The various subdirectories
#
##########
IDL_DIRS        =
PURE_JAVA_DIRS  =
PURE_CXX_DIRS   =
LINKED_DIRS     = 

# All headers

HEADERS      =	\
		N_vector.h \
		absorbwa.h \
		beamemit.h \
		boltzman.h \
		boundary.h \
		cg.h \
		complex.h \
		conducto.h \
		cylindri.h \
		dadi.h \
		dadirz.h \
		dadixy.h \
		dadixyp.h \
		define.h \
		dielectr.h \
		domain.h \
		electrostatic_operator.h \
		emitport.h \
		emitter.h \
		eqpot.h \
		exitport.h \
		fieldemi.h \
		fields.h \
		foil.h \
		gap.h \
		gmres.h \
		gpdist.h \
		grid.h \
		iloop.h \
		inverter.h \
		iregion.h \
		launchwa.h \
		load.h \
		maxwelln.h \
		mcc.h \
		mg_utils.h \
		misc.h \
		multigrid.h \
		parpoi.h \
		particle.h \
		periodic.h \
		plsmadev.h \
		plsmasrc.h \
		polar.h \
		port.h \
		portsumte.h \
		portte.h \
		porttm.h \
		psolve.h \
		ptclgpes.h \
		ptclgpib.h \
		ptclgpnr.h \
		ptclgpsr.h \
		ptclgrp.h \
		secondary.h \
		spblink.h \
		spbound.h \
		species.h
		spemit.h \
		sptlrgn.h \
		symmetry.h \
		timefunc.h \
		varload.h \
		vbmemit.h \
		vector.h \
		vmaxwelln.h
		
# Source files for creation of main target (library)

SOURCES     =	\
		absorbwa.cpp \
		beamemit.cpp \
		boltzman.cpp \
		boundary.cpp \
		cg.cpp \
		conducto.cpp \
		cylindri.cpp \
		dadi.cpp \
		dadirz.cpp \
		dadixy.cpp \
		dadixyp.cpp \
		dielectr.cpp \
		domain.cpp \
		electrostatic_operator.cpp \
		emitter.cpp \
		eqpot.cpp \
		exitport.cpp \
		fieldemi.cpp \
		fields.cpp \
		foil.cpp \
		gap.cpp \
		gmres.cpp \
		gpdist.cpp \
		grid.cpp \
		iloop.cpp \
		iregion.cpp \
		launchwa.cpp \
		load.cpp \
		maxwelln.cpp \
		mcc.cpp \
		mg_utils.cpp \
		misc.cpp \
		multigrid.cpp \
		parpoi.cpp \
		periodic.cpp \
		plsmadev.cpp \
		plsmasrc.cpp \
		polar.cpp \
		port.cpp \
		portsumte.cpp \
		portte.cpp \
		porttm.cpp \
		psolve.cpp \
		ptclgpes.cpp \
		ptclgpib.cpp \
		ptclgpnr.cpp \
		ptclgpsr.cpp \
		ptclgrp.cpp \
		secondary.cpp \
		spblink.cpp \
		spbound.cpp \
		sptlrgn.cpp \
		varload.cpp \
		vbmemit.cpp \
		vmaxwelln.cpp
		
# Additional testing executables

EXECS =

# Additional files to remove with "make clean"

CLEAN_FILES  =

##########
#
# Distribution variables
#
##########

# The DIST_* variables denote items for all distributions
DIST_DIR	= ../oopic/physics
DIST_DIRS	=
DIST_CXX_DIRS	=
DIST_EXTS	= .h .cpp
DIST_ITEMS	= 

# The variables describing extra files needed by each of
# the DIST_TYPE's: UNIX_EQ, BORLAND, WIN32_MWERKS, MACOS_MWERKS, MSVC

UNIX_EQ_ITEMS	= 
UNIX_EQ_EXTS	=
BORLAND_ITEMS	=
BORLAND_EXTS	=
MSVC_ITEMS	=
MSVC_EXTS	=
WIN32_MWERKS_ITEMS	=
WIN32_MWERKS_EXTS	=
MACOS_MWERKS_ITEMS	=
MACOS_MWERKS_EXTS	=
