/*
====================================================================

portgauss.h

   Class representing a boundary on which a wave type boundary
   condition is applied.

====================================================================
*/

#ifndef	__PORTGAUSS_H
#define	__PORTGAUSS_H

#include "ovector.h"
#include "misc.h"
#include "particle.h"
#include "boundary.h"


class PortGauss : public Boundary
{
 protected:
    Grid* grid;
    Scalar rforEr, Er, intEr, A1, a;
    Scalar EnergyOut, HonBoundary;
    int K, EFFlag, shift;
    Scalar time, tOld, dt;
    Scalar gauss_w, gauss_rl, omegag, zf, Agw;
    Scalar wz, Rz, phig, kg, wz2, zp2, zp02, zb;

 public:
    PortGauss(oopicList <LineSegment> *segments, int _EFFlag,
    Scalar _gauss_w, Scalar _gauss_rl, Scalar _omegag, Scalar _zf,
    Scalar _Agw);
    virtual void applyFields(Scalar t, Scalar dt);
    virtual ParticleList& emit(Scalar t, Scalar dt, Species *species);
    virtual void setPassives();
};

#endif	//	ifndef __PORTGAUSS_H
