######################################################################
#
# File:	        xg.pro
#
# Purpose:	tmake project file for xg
#
# Version:	$Id: xg.pro,v 1.1.2.2 2000/01/18 23:50:54 kgl Exp $
#
# Copyright 1999, Tech-X Corporation
#
######################################################################

##########
#
# tmake stuff
#
##########
TEMPLATE	= xg
TARGET		= xgmain
CONFIG		= cxx xgrafix staticlib develop 

##########
#
# Other directories in the hierarchy
#
##########
THIS_DIR        = xg
TOP_DIR         = ..
TXCORP_DIR      =
PROJ_DIR        = $(HOME)/projects
RULES_DIR       = $(PROJ_DIR)/projrules
RULES_FILE      = $(RULES_DIR)/$(PROJ_ENV)/rules
DOCS_DIR        = $(TOP_DIR)/docs/cxxapi/xg
DOCS_PACKAGES   =
THIS_PACKAGE    =

##########
#
# Locations for libraries, class files, and archives
#
##########
PROJ_LIB_DIR	= $(TOP_DIR)/lib
PROJ_JSRCS_DIR	=
PROJ_CLASSES_DIR= $(TOP_DIR)/classes

##########
#
# Other libraries that this depends on and compilation defines
#
##########
PROJ_DEPS       = advisor physics
PROJ_DEFINES	= UNIX SCALAR_FLOAT
PROJ_LIBS       = advisor physics xgmain

##########
#
# The various subdirectories
#
##########
IDL_DIRS        =
PURE_JAVA_DIRS  =
PURE_CXX_DIRS   =
LINKED_DIRS     = 

# All headers

HEADERS      =	\
		fft.h \
		globalvars.h \
		gridprob.h \
		history.h \
		list.h \
		newdiag.h \
		ostring.h \
		probergn.h \
		physics.h
		
# Source files for creation of main target (library)

SOURCES     =	\
		c_utils.c \
		evaluator.tab.c \
		fft.c \
		diagn.cpp \
		dump.cpp \
		gridprob.cpp \
		history.cpp \
		initwin.cpp \
		main.cpp \
		newdiag.cpp \
		probergn.cpp \
		physics.cpp

# Additional testing executables

EXECS = xgmain

# Additional files to remove with "make clean"

CLEAN_FILES  =

##########
#
# Distribution variables
#
##########

# The DIST_* variables denote items for all distributions
DIST_DIR	= ../oopic/xg
DIST_DIRS	=
DIST_CXX_DIRS	=
DIST_EXTS	= .h .cpp
DIST_ITEMS	= 

# The variables describing extra files needed by each of
# the DIST_TYPE's: UNIX_EQ, BORLAND, WIN32_MWERKS, MACOS_MWERKS, MSVC

UNIX_EQ_ITEMS	= 
UNIX_EQ_EXTS	=
BORLAND_ITEMS	=
BORLAND_EXTS	=
MSVC_ITEMS	=
MSVC_EXTS	=
WIN32_MWERKS_ITEMS	=
WIN32_MWERKS_EXTS	=
MACOS_MWERKS_ITEMS	=
MACOS_MWERKS_EXTS	=
